Index: .hgsubstate
===================================================================
--- .hgsubstate	(revision 3322)
+++ .hgsubstate	(revision 3351)
@@ -1,1 +1,1 @@
-19853ae41c45fd219679e2b3a5281c76e0b0d690 inc/libs/clearbricks
+76a26334ed34e15e59020cd2b4b94d57f6fa4739 inc/libs/clearbricks
Index: admin/auth.php
===================================================================
--- admin/auth.php	(revision 3352)
+++ admin/auth.php	(revision 3275)
@@ -29,9 +29,5 @@
 }
 
-if (defined('DC_ADMIN_URL')) {
-	$page_url = DC_ADMIN_URL.$core->adminurl->get('admin.auth');
-} else {
-	$page_url = http::getHost().$_SERVER['REQUEST_URI'];
-}
+$page_url = http::getHost().$_SERVER['REQUEST_URI'];
 
 $change_pwd = $core->auth->allowPassChange() && isset($_POST['new_pwd']) && isset($_POST['new_pwd_c']) && isset($_POST['login_data']);
Index: admin/blog_pref.php
===================================================================
--- admin/blog_pref.php	(revision 3270)
+++ admin/blog_pref.php	(revision 3330)
@@ -313,4 +313,9 @@
 
 $desc_editor = $core->auth->getOption('editor');
+$rte_flag = true;
+$rte_flags  = @$core->auth->user_prefs->interface->rte_flags;
+if (is_array($rte_flags) && in_array('blog_descr',$rte_flags)) {
+	$rte_flag = $rte_flags['blog_descr'];
+}
 
 dcPage::open(__('Blog settings'),
@@ -324,7 +329,6 @@
 	"</script>".
 	dcPage::jsConfirmClose('blog-form').
-	$core->callBehavior('adminPostEditor',$desc_editor['xhtml'],'blog_desc',array('#blog_desc'),'xhtml').
+	($rte_flag ? $core->callBehavior('adminPostEditor',$desc_editor['xhtml'],'blog_desc',array('#blog_desc'),'xhtml') : '').
 	dcPage::jsLoad('js/_blog_pref.js').
-
 
 	# --BEHAVIOR-- adminBlogPreferencesHeaders
Index: admin/categories.php
===================================================================
--- admin/categories.php	(revision 3210)
+++ admin/categories.php	(revision 3340)
@@ -47,5 +47,5 @@
 		$mov_cat = (int) $_POST['mov_cat'][$cat_id];
 
-		$mov_cat = $mov_cat ? $mov_cat : null;
+		$mov_cat = $mov_cat ?: null;
 		if ($mov_cat !== null) {
 			$c = $core->blog->getCategory($mov_cat);
Index: admin/category.php
===================================================================
--- admin/category.php	(revision 3209)
+++ admin/category.php	(revision 3330)
@@ -175,9 +175,14 @@
 
 $category_editor = $core->auth->getOption('editor');
+$rte_flag = true;
+$rte_flags  = @$core->auth->user_prefs->interface->rte_flags;
+if (is_array($rte_flags) && in_array('cat_descr',$rte_flags)) {
+	$rte_flag = $rte_flags['cat_descr'];
+}
 
 dcPage::open($title,
 	dcPage::jsConfirmClose('category-form').
 	dcPage::jsLoad('js/_category.js').
-	$core->callBehavior('adminPostEditor',$category_editor['xhtml'],'category',array('#cat_desc'),'xhtml'),
+	($rte_flag ? $core->callBehavior('adminPostEditor',$category_editor['xhtml'],'category',array('#cat_desc'),'xhtml') : ''),
 	dcPage::breadcrumb($elements)
 );
Index: admin/comments.php
===================================================================
--- admin/comments.php	(revision 3263)
+++ admin/comments.php	(revision 3342)
@@ -43,4 +43,5 @@
 __('Date') => 'comment_dt',
 __('Entry title') => 'post_title',
+__('Entry date') => 'post_dt',
 __('Author') => 'comment_author',
 __('Status') => 'comment_status'
Index: admin/csp_report.php
===================================================================
--- admin/csp_report.php	(revision 3293)
+++ admin/csp_report.php	(revision 3324)
@@ -8,6 +8,8 @@
 header('X-Content-Type-Options: "nosniff"');
 
+require dirname(__FILE__).'/../inc/admin/prepend.php';
+
 // Specify log file
-define('LOGFILE',dirname(__FILE__).'/csp_report.txt');
+define('LOGFILE',path::real(DC_TPL_CACHE).'/csp_report.txt');
 
 // Get the raw POST data
Index: admin/install/index.php
===================================================================
--- admin/install/index.php	(revision 3303)
+++ admin/install/index.php	(revision 3326)
@@ -172,4 +172,5 @@
 		# CSP directive (admin part)
 		$blog_settings->system->put('csp_admin_on',true,'boolean','Send CSP header (admin)',true,true);
+		$blog_settings->system->put('csp_admin_report_only',false,'boolean','CSP Report only violations (admin)',true,true);
 		$blog_settings->system->put('csp_admin_default',"'self'",'string','CSP default-src directive',true,true);
 		$blog_settings->system->put('csp_admin_script',"'self' 'unsafe-inline' 'unsafe-eval'",'string','CSP script-src directive',true,true);
Index: admin/js/common.js
===================================================================
--- admin/js/common.js	(revision 3294)
+++ admin/js/common.js	(revision 3332)
@@ -604,6 +604,7 @@
         });
 
-        $('#gototop').click(function() {
+        $('#gototop').click(function(e) {
             $('body,html').animate({scrollTop:0},800);
+            e.preventDefault();
         });
 });
Index: admin/js/jquery/jquery.pageTabs.js
===================================================================
--- admin/js/jquery/jquery.pageTabs.js	(revision 2479)
+++ admin/js/jquery/jquery.pageTabs.js	(revision 3333)
@@ -1,5 +1,5 @@
 (function($) {
 	'use strict';
-    
+
 	$.pageTabs = function(start_tab, opts) {
 		var defaults = {
@@ -10,8 +10,9 @@
 			idTabPrefix: 'part-tabs-'
 		};
-		
+
 		$.pageTabs.options = $.extend({}, defaults, opts);
 		var active_tab = start_tab || '';
 		var hash = $.pageTabs.getLocationHash();
+		var subhash = $.pageTabs.getLocationSubhash();
 
 		if (hash !== undefined && hash) {
@@ -23,5 +24,5 @@
 
 		createTabs();
-		
+
 		$('ul li', '.'+$.pageTabs.options.containerClass).click(function(e) {
 			if ($(this).hasClass($.pageTabs.options.activeClass)) {
@@ -40,5 +41,5 @@
 				part_to_activate.addClass('loaded');
 			}
-			
+
 			part_to_activate.tabload();
 		});
@@ -49,11 +50,16 @@
 
 		$.pageTabs.clickTab(active_tab);
-		
+
+		if (subhash !== undefined) {
+			// Tab displayed, now scroll to the sub-part if defined in original document.location (#tab.sub-part)
+			document.getElementById(subhash).scrollIntoView();
+		}
+
 		return this;
 	};
-	
+
 	var createTabs = function createTabs() {
 		var lis = [], li_class = '';
-		
+
 		$('.'+$.pageTabs.options.contentClass).each(function() {
 			$(this).hide();
@@ -62,9 +68,9 @@
 			$(this).attr('id', $.pageTabs.options.partPrefix + $(this).attr('id')).prop('title','');
 		});
-		
+
 		$('<div class="'+$.pageTabs.options.containerClass+'"><ul>'+lis.join('')+'</ul></div>')
 			.insertBefore($('.'+$.pageTabs.options.contentClass).get(0));
 	};
-	
+
 	var getHash = function getHash(href) {
 		var href = href || '';
@@ -72,5 +78,5 @@
 		return href.replace(/.*#/, '');
 	};
-	
+
 	$.pageTabs.clickTab = function(tab) {
 		if (tab=='') {
@@ -96,5 +102,12 @@
 
 	$.pageTabs.getLocationHash = function() {
-		return getHash(document.location.hash);
+		// Return the URL hash (without subhash — #hash[.subhash])
+		var h = getHash(document.location.hash).split('.');
+		return h[0];
+	};
+	$.pageTabs.getLocationSubhash = function() {
+		// Return the URL subhash if present (without hash — #hash[.subhash])
+		var sh = getHash(document.location.hash).split('.');
+		return sh[1];
 	};
 })(jQuery);
Index: admin/media.php
===================================================================
--- admin/media.php	(revision 3295)
+++ admin/media.php	(revision 3340)
@@ -35,5 +35,5 @@
 
 $page = !empty($_GET['page']) ? max(1,(integer) $_GET['page']) : 1;
-$nb_per_page = ((integer) $core->auth->user_prefs->interface->media_by_page ? (integer) $core->auth->user_prefs->interface->media_by_page : 30);
+$nb_per_page = ((integer) $core->auth->user_prefs->interface->media_by_page ?: 30);
 
 # We are on home not comming from media manager
@@ -75,8 +75,14 @@
 $file_mode = !empty($_SESSION['media_file_mode']) ? $_SESSION['media_file_mode'] : 'grid';
 
-if (!empty($_GET['file_sort']) && in_array($_GET['file_sort'],$sort_combo)) {
-	$_SESSION['media_file_sort'] = $_GET['file_sort'];
-}
-$file_sort = !empty($_SESSION['media_file_sort']) ? $_SESSION['media_file_sort'] : null;
+$file_sort = null;
+if (!empty($_GET['file_sort'])) {
+	$file_sort = $_SESSION['media_file_sort'] = $_GET['file_sort'];
+	setcookie('dc_media_sort',json_encode($file_sort));
+} elseif (isset($_COOKIE['dc_media_sort'])) {
+	$file_sort = json_decode($_COOKIE['dc_media_sort']);
+} elseif (!empty($_SESSION['media_file_sort'])) {
+	$file_sort = $_SESSION['media_file_sort'];
+}
+$file_sort =  in_array($file_sort,$sort_combo) ? $file_sort : null;
 
 $nb_per_page = !empty($_SESSION['nb_per_page']) ? (integer)$_SESSION['nb_per_page'] : $nb_per_page;
@@ -155,5 +161,5 @@
 			$zip->addDirectory($core->media->root.'/'.$d,'',true);
 
-			header('Content-Disposition: attachment;filename='.date('Y-m-d').'-'.$core->blog->id.'-'.($d ? $d : 'media').'.zip');
+			header('Content-Disposition: attachment;filename='.date('Y-m-d').'-'.$core->blog->id.'-'.($d ?: 'media').'.zip');
 			header('Content-Type: application/x-zip');
 			$zip->write();
Index: admin/media_item.php
===================================================================
--- admin/media_item.php	(revision 3167)
+++ admin/media_item.php	(revision 3353)
@@ -185,5 +185,5 @@
 
 # Function to get image title based on meta
-function dcGetImageTitle($file,$pattern,$dto_first=false,$no_date_alone=false)
+$get_img_title = function ($file,$pattern,$dto_first=false,$no_date_alone=false)
 {
 	$res = array();
@@ -225,5 +225,5 @@
 	}
 	return implode($sep,$res);
-}
+};
 
 /* DISPLAY Main page
@@ -307,5 +307,5 @@
 	{
 		$media_type = 'image';
-		$media_desc = dcGetImageTitle($file,
+		$media_desc = $get_img_title($file,
 			$core->blog->settings->system->media_img_title_pattern,
 			$core->blog->settings->system->media_img_use_dto_first,
@@ -376,5 +376,5 @@
 	{
 		$media_type = 'image';
-		$media_desc = dcGetImageTitle($file,
+		$media_desc = $get_img_title($file,
 			$core->blog->settings->system->media_img_title_pattern,
 			$core->blog->settings->system->media_img_use_dto_first,
Index: admin/plugin.php
===================================================================
--- admin/plugin.php	(revision 2708)
+++ admin/plugin.php	(revision 3333)
@@ -78,4 +78,11 @@
 	call_user_func($open_f,$p_title,$p_head);
 	echo $p_content;
+	if (!$popup) {
+		// Add direct links to plugin settings if any
+		$settings = adminModulesList::getSettingsUrls($core,$p,true,false);
+		if (!empty($settings)) {
+			echo '<hr class="clear"/><p class="right modules">'.implode(' - ',$settings).'</p>';
+		}
+	}
 	call_user_func($close_f);
 }
Index: admin/post.php
===================================================================
--- admin/post.php	(revision 3209)
+++ admin/post.php	(revision 3340)
@@ -272,5 +272,5 @@
 
 	$cur->post_title = $post_title;
-	$cur->cat_id = ($cat_id ? $cat_id : null);
+	$cur->cat_id = ($cat_id ?: null);
 	$cur->post_dt = $post_dt ? date('Y-m-d H:i:00',strtotime($post_dt)) : '';
 	$cur->post_format = $post_format;
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 3265)
+++ admin/preferences.php	(revision 3340)
@@ -47,5 +47,5 @@
 $user_ui_iconset = @$core->auth->user_prefs->interface->iconset;
 $user_ui_nofavmenu = $core->auth->user_prefs->interface->nofavmenu;
-$user_ui_media_by_page = ($core->auth->user_prefs->interface->media_by_page ? $core->auth->user_prefs->interface->media_by_page : 30);
+$user_ui_media_by_page = ($core->auth->user_prefs->interface->media_by_page ?: 30);
 $user_ui_media_nb_last_dirs = $core->auth->user_prefs->interface->media_nb_last_dirs;
 
@@ -98,4 +98,21 @@
 # Language codes
 $lang_combo = dcAdminCombos::getAdminLangsCombo();
+
+# Get 3rd parts xhtml editor flags
+$rte = array(
+	'blog_descr' => array(true,__('Blog description (in blog parameters)')),
+	'cat_descr' => array(true,__('Category description'))
+);
+$rte = new ArrayObject($rte);
+$core->callBehavior('adminRteFlags',$core,$rte);
+# Load user settings
+$rte_flags = @$core->auth->user_prefs->interface->rte_flags;
+if (is_array($rte_flags)) {
+	foreach ($rte_flags as $fk => $fv) {
+		if (isset($rte[$fk])) {
+			$rte[$fk][0] = $fv;
+		}
+	}
+}
 
 # Get default colums (admin lists)
@@ -233,4 +250,11 @@
 		}
 		$core->auth->user_prefs->interface->put('cols',$cu,'array');
+
+		# Update user xhtml editor flags
+		$rf = array();
+		foreach ($rte as $rk => $rv) {
+			$rf[$rk] = isset($_POST['rte_flags']) && in_array($rk,$_POST['rte_flags'],true) ? true : false;
+		}
+		$core->auth->user_prefs->interface->put('rte_flags',$rf,'array');
 
 		# Update user
@@ -466,5 +490,5 @@
 echo
 '<div class="fieldset">'.
-'<h4>'.__('Interface').'</h4>'.
+'<h4 id="user_options_interface">'.__('Interface').'</h4>'.
 
 '<p><label for="user_ui_enhanceduploader" class="classic">'.
@@ -500,12 +524,16 @@
 echo
 '<div class="fieldset">'.
-'<h4>'.__('Optional columns displayed in lists').'</h4>';
+'<h4 id="user_options_columns">'.__('Optional columns displayed in lists').'</h4>';
+$odd = true;
 foreach ($cols as $col_type => $col_list) {
+	echo '<div class="two-boxes '.($odd ? 'odd' : 'even').'">';
 	echo '<h5>'.$col_list[0].'</h5>';
 	foreach ($col_list[1] as $col_name => $col_data) {
 		echo
-		'<p><label for="cols_'.$col_type.'-"'.$col_name.'" class="classic">'.
+		'<p><label for="cols_'.$col_type.'-'.$col_name.'" class="classic">'.
 		form::checkbox(array('cols_'.$col_type.'[]','cols_'.$col_type.'-'.$col_name),$col_name,$col_data[0]).$col_data[1].'</label>';
 	}
+	echo '</div>';
+	$odd = !$odd;
 }
 echo '</div>';
@@ -513,6 +541,7 @@
 echo
 '<div class="fieldset">'.
-'<h4>'.__('Edition').'</h4>';
-
+'<h4 id="user_options_edition">'.__('Edition').'</h4>';
+
+echo '<div class="two-boxes odd">';
 foreach ($format_by_editors as $format => $editors) {
 	echo
@@ -544,4 +573,15 @@
 
 '</div>';
+
+echo '<div class="two-boxes even">';
+echo '<h5>'.__('Use xhtml editor for:').'</h5>';
+foreach ($rte as $rk => $rv) {
+	echo
+		'<p><label for="rte_'.$rk.'" class="classic">'.
+		form::checkbox(array('rte_flags[]','rte_'.$rk),$rk,$rv[0]).$rv[1].'</label>';
+}
+echo '</div>';
+
+echo '</div>';	// fieldset
 
 echo
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 3319)
+++ inc/admin/lib.dc.page.php	(revision 3340)
@@ -106,8 +106,8 @@
 			// Get directives from settings if exist, else set defaults
 			$csp = new ArrayObject(array());
-			$csp['default-src'] = $core->blog->settings->system->csp_admin_default ? $core->blog->settings->system->csp_admin_default : "'self'";
-			$csp['script-src'] = $core->blog->settings->system->csp_admin_script ? $core->blog->settings->system->csp_admin_script : "'self' 'unsafe-inline' 'unsafe-eval'";
-			$csp['style-src'] = $core->blog->settings->system->csp_admin_style ? $core->blog->settings->system->csp_admin_style : "'self' 'unsafe-inline'";
-			$csp['img-src'] = $core->blog->settings->system->csp_admin_img ? $core->blog->settings->system->csp_admin_img : "'self' data: media.dotaddict.org";
+			$csp['default-src'] = $core->blog->settings->system->csp_admin_default ?: "'self'";
+			$csp['script-src'] = $core->blog->settings->system->csp_admin_script ?: "'self' 'unsafe-inline' 'unsafe-eval'";
+			$csp['style-src'] = $core->blog->settings->system->csp_admin_style ?: "'self' 'unsafe-inline'";
+			$csp['img-src'] = $core->blog->settings->system->csp_admin_img ?: "'self' data: media.dotaddict.org";
 
 			# Cope with blog post preview (via public URL in iframe)
@@ -137,5 +137,6 @@
 					$directives[] = "report-uri ".DC_ADMIN_URL."csp_report.php";
 				}
-				$headers['csp'] = "Content-Security-Policy: ".implode(" ; ",$directives);
+				$report_only = ($core->blog->settings->system->csp_admin_report_only) ? '-Report-Only' : '';
+				$headers['csp'] = "Content-Security-Policy".$report_only.": ".implode(" ; ",$directives);
 			}
 		}
@@ -297,5 +298,5 @@
 	{
 		global $core;
-		$tag = (isset($n['divtag'])&& $n['divtag'])?'div':'p';
+		$tag = (isset($n['divtag']) && $n['divtag']) ? 'div' : 'p';
 		$ts = '';
 		if (!isset($n['with_ts']) || ($n['with_ts'] == true)) {
@@ -441,7 +442,7 @@
 	{
 		global $core;
-		$with_home_link = isset($options['home_link'])?$options['home_link']:true;
-		$hl = isset($options['hl'])?$options['hl']:true;
-		$hl_pos = isset($options['hl_pos'])?$options['hl_pos']:-1;
+		$with_home_link = isset($options['home_link']) ? $options['home_link'] : true;
+		$hl = isset($options['hl']) ? $options['hl'] : true;
+		$hl_pos = isset($options['hl_pos']) ? $options['hl_pos'] : -1;
 		// First item of array elements should be blog's name, System or Plugins
 		$res = '<h2>'.($with_home_link ?
@@ -1053,4 +1054,5 @@
 					}
 				}
+				sort($themes);
 			}
 		}
Index: inc/admin/lib.moduleslist.php
===================================================================
--- inc/admin/lib.moduleslist.php	(revision 3327)
+++ inc/admin/lib.moduleslist.php	(revision 3338)
@@ -466,5 +466,7 @@
 				'sshot' 			=> '',
 				'score'				=> 0,
-				'type' 				=> null
+				'type' 				=> null,
+				'require'			=> array(),
+				'settings'			=> array()
 			),
 			# Module's values
@@ -744,5 +746,5 @@
 					if (!empty($more)) {
 						echo
-						'<li>'.implode(' - ', $more).'</li>';
+						'<li>'.implode(' - ',$more).'</li>';
 					}
 
@@ -752,12 +754,17 @@
 
 				$config = !empty($module['root']) && file_exists(path::real($module['root'].'/_config.php'));
-
-				if ($config || !empty($module['section']) || !empty($module['tags'])) {
+				$index = !empty($module['root']) && file_exists(path::real($module['root'].'/index.php'));
+
+				if ($config || $index || !empty($module['section']) || !empty($module['tags']) || !empty($module['settings'])) {
 					echo
 					'<div><ul class="mod-more">';
 
-					if ($config) {
-						echo
-						'<li><a class="module-config" href="'.$this->getURL('module='.$id.'&amp;conf=1').'">'.__('Configure plugin').'</a></li>';
+					if ($index && $module['enabled']) {
+						echo '<li><a href="'.$this->core->adminurl->get('admin.plugin.'.$id).'">'.__('Manage plugin').'</a></li>';
+					}
+
+					$settings = $this->getSettingsUrls($this->core,$id);
+					if (!empty($settings) && $module['enabled']) {
+						echo '<li>'.implode(' - ',$settings).'</li>';
 					}
 
@@ -806,4 +813,78 @@
 
 		return $this;
+	}
+
+	/**
+	 * Get settings URLs if any
+	 *
+	 * @param object $core
+	 * @param string $id module ID
+	 * @param boolean $check check permission
+	 * @param boolean $self include self URL (→ plugin index.php URL)
+	 * @return Array of settings URLs
+	 */
+	public static function getSettingsUrls($core,$id,$check=false,$self=true)
+	{
+		$st = array();
+
+		$config = !empty($core->plugins->moduleRoot($id)) &&
+			file_exists(path::real($core->plugins->moduleRoot($id).'/_config.php'));
+		$settings = $core->plugins->moduleInfo($id,'settings');
+		if ($config || !empty($settings)) {
+			if ($config) {
+				if (!$check ||
+					$core->auth->isSuperAdmin() ||
+					$core->auth->check($core->plugins->moduleInfo($id,'permissions'),$core->blog->id))
+				{
+					$params = array('module' => $id,'conf' => '1');
+					if (!$core->plugins->moduleInfo($id,'standalone_config') && !$self) {
+						$params['redir'] = $core->adminurl->get('admin.plugin.'.$id);
+					}
+					$st[] = '<a class="module-config" href="'.
+						$core->adminurl->get('admin.plugins',$params).
+						'">'.__('Configure plugin').'</a>';
+				}
+			}
+			if (is_array($settings)) {
+				foreach ($settings as $sk => $sv) {
+					switch ($sk) {
+						case 'blog':
+							if (!$check ||
+								$core->auth->isSuperAdmin() ||
+								$core->auth->check('admin',$core->blog->id))
+							{
+								$st[] = '<a class="module-config" href="'.
+									$core->adminurl->get('admin.blog.pref').$sv.
+									'">'.__('Plugin settings (in blog parameters)').'</a>';
+							}
+							break;
+						case 'pref':
+							if (!$check ||
+								$core->auth->isSuperAdmin() ||
+								$core->auth->check('usage,contentadmin',$core->blog->id))
+							{
+								$st[] = '<a class="module-config" href="'.
+									$core->adminurl->get('admin.user.preferences').$sv.
+									'">'.__('Plugin settings (in user preferences)').'</a>';
+							}
+							break;
+						case 'self':
+							if ($self) {
+								if (!$check ||
+									$core->auth->isSuperAdmin() ||
+									$core->auth->check($core->plugins->moduleInfo($id,'permissions'),$core->blog->id))
+								{
+									$st[] = '<a class="module-config" href="'.
+										$core->adminurl->get('admin.plugin.'.$id).$sv.
+										'">'.__('Plugin settings').'</a>';
+								}
+							}
+							break;
+					}
+				}
+			}
+		}
+
+		return $st;
 	}
 
Index: inc/admin/lib.themeconfig.php
===================================================================
--- inc/admin/lib.themeconfig.php	(revision 2660)
+++ inc/admin/lib.themeconfig.php	(revision 3340)
@@ -71,5 +71,5 @@
 
 		// Eval font size in em (assume base font size in pixels equal to 16)
-		if (preg_match('/^([0-9.]+)\s*(%|pt|px|em|ex)?$/',$size,$m)) {
+		if (preg_match('/^([0-9.]+)\s*(%|pt|px|em|ex|rem)?$/',$size,$m)) {
 			if (empty($m[2])) {
 				$m[2] = 'em';
@@ -144,5 +144,5 @@
 	public static function adjustFontSize($s)
 	{
-		if (preg_match('/^([0-9.]+)\s*(%|pt|px|em|ex)?$/',$s,$m)) {
+		if (preg_match('/^([0-9.]+)\s*(%|pt|px|em|ex|rem)?$/',$s,$m)) {
 			if (empty($m[2])) {
 				$m[2] = 'em';
Index: inc/admin/prepend.php
===================================================================
--- inc/admin/prepend.php	(revision 3262)
+++ inc/admin/prepend.php	(revision 3334)
@@ -64,5 +64,5 @@
 }
 
-function addMenuItem($section,$desc,$adminurl,$icon,$perm)
+function addMenuItem($section,$desc,$adminurl,$icon,$perm,$pinned=false)
 {
 	global $core,$_menu;
@@ -70,5 +70,5 @@
 	$url = $core->adminurl->get($adminurl);
 	$_menu[$section]->prependItem($desc,$url,$icon,
-		preg_match('/'.preg_quote($url).'(\?.*)?$/',$_SERVER['REQUEST_URI']),$perm,null,null,true);
+		preg_match('/'.preg_quote($url).'(\?.*)?$/',$_SERVER['REQUEST_URI']),$perm,null,null,$pinned);
 }
 
@@ -278,5 +278,5 @@
 		$core->auth->check('usage,contentadmin',$core->blog->id));
 	addMenuItem('Blog',__('New entry'),'admin.post','images/menu/edit.png',
-		$core->auth->check('usage,contentadmin',$core->blog->id));
+		$core->auth->check('usage,contentadmin',$core->blog->id),true);
 
 	addMenuItem('System',__('Update'),'admin.update','images/menu/update.png',
Index: inc/core/class.dc.auth.php
===================================================================
--- inc/core/class.dc.auth.php	(revision 3298)
+++ inc/core/class.dc.auth.php	(revision 3340)
@@ -217,5 +217,5 @@
 		# Check here for user and IP address
 		$this->checkUser($_SESSION['sess_user_id']);
-		$uid = $uid ? $uid : http::browserUID(DC_MASTER_KEY);
+		$uid = $uid ?: http::browserUID(DC_MASTER_KEY);
 
 		$user_can_log = $this->userID() !== null && $uid == $_SESSION['sess_browser_uid'];
Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 3263)
+++ inc/core/class.dc.blog.php	(revision 3340)
@@ -1506,5 +1506,5 @@
 		$cur = $this->con->openCursor($this->prefix.'post');
 
-		$cur->cat_id = ($cat_id ? $cat_id : null);
+		$cur->cat_id = ($cat_id ?: null);
 		$cur->post_upddt = date('Y-m-d H:i:s');
 
@@ -1530,5 +1530,5 @@
 		$cur = $this->con->openCursor($this->prefix.'post');
 
-		$cur->cat_id = ($new_cat_id ? $new_cat_id : null);
+		$cur->cat_id = ($new_cat_id ?: null);
 		$cur->post_upddt = date('Y-m-d H:i:s');
 
Index: inc/core/class.dc.media.php
===================================================================
--- inc/core/class.dc.media.php	(revision 3299)
+++ inc/core/class.dc.media.php	(revision 3340)
@@ -393,5 +393,5 @@
 		}
 
-		$media_dir = $this->relpwd ? $this->relpwd : '.';
+		$media_dir = $this->relpwd ?: '.';
 
 		$strReq =
@@ -660,5 +660,5 @@
 	protected function rebuildDB($pwd)
 	{
-		$media_dir = $pwd ? $pwd : '.';
+		$media_dir = $pwd ?: '.';
 
 		$strReq =
@@ -919,5 +919,5 @@
 	public function getDBDirs()
 	{
-		$media_dir = $this->relpwd ? $this->relpwd : '.';
+		$media_dir = $this->relpwd ?: '.';
 
 		$strReq =
Index: inc/core/class.dc.modules.php
===================================================================
--- inc/core/class.dc.modules.php	(revision 3135)
+++ inc/core/class.dc.modules.php	(revision 3333)
@@ -283,5 +283,5 @@
 	(currently available keys : permissions, priority, type)
 	*/
-	public function registerModule($name,$desc,$author,$version, $properties = array())
+	public function registerModule($name,$desc,$author,$version,$properties = array())
 	{
 		if ($this->disabled_mode) {
@@ -320,5 +320,6 @@
 				'type' => null,
 				'enabled' => true,
-				'requires' => array()
+				'requires' => array(),
+				'settings' => array()
 			), $properties
 		);
Index: inc/core/class.dc.trackback.php
===================================================================
--- inc/core/class.dc.trackback.php	(revision 2674)
+++ inc/core/class.dc.trackback.php	(revision 3340)
@@ -171,5 +171,5 @@
 		$comment =
 		"<!-- TB -->\n".
-		'<p><strong>'.($title ? $title : $blog_name)."</strong></p>\n".
+		'<p><strong>'.($title ?: $blog_name)."</strong></p>\n".
 		'<p>'.$excerpt.'</p>';
 
Index: inc/core/class.dc.update.php
===================================================================
--- inc/core/class.dc.update.php	(revision 2566)
+++ inc/core/class.dc.update.php	(revision 3350)
@@ -104,14 +104,35 @@
 		{
 			$path = '';
-			$client = netHttp::initClient($this->url,$path);
-			if ($client !== false) {
-				$client->setTimeout(4);
-				$client->setUserAgent($_SERVER['HTTP_USER_AGENT']);
-				$client->get($path);
-
-				$this->readVersion($client->getContent());
-			}
-		}
-		catch (Exception $e) {}
+			$status = 0;
+
+			$http_get = function ($http_url) use (&$status,$path) {
+				$client = netHttp::initClient($http_url,$path);
+				if ($client !== false) {
+					$client->setTimeout(4);
+					$client->setUserAgent($_SERVER['HTTP_USER_AGENT']);
+					$client->get($path);
+					$status = (int) $client->getStatus();
+				}
+				return $client;
+			};
+
+			$client = $http_get($this->url);
+			if ($status >= 400) {
+				// If original URL uses HTTPS, try with HTTP
+				$url_parts = parse_url($client->getRequestURL());
+				if (isset($url_parts['scheme']) && $url_parts['scheme'] == 'https') {
+					// Replace https by http in url
+					$this->url = preg_replace('/^https(?=:\/\/)/i','http',$this->url);
+					$client = $http_get($this->url);
+				}
+			}
+			if (!$status || $status >= 400) {
+				throw new Exception();
+			}
+			$this->readVersion($client->getContent());
+		}
+		catch (Exception $e) {
+			return;
+		}
 
 		# Create cache
@@ -202,13 +223,32 @@
 		try
 		{
-			$client = netHttp::initClient($url,$path);
-			$client->setTimeout(4);
-			$client->setUserAgent($_SERVER['HTTP_USER_AGENT']);
-			$client->useGzip(false);
-			$client->setPersistReferers(false);
-			$client->setOutput($dest);
-			$client->get($path);
-
-			if ($client->getStatus() != 200) {
+			$path = '';
+			$status = 0;
+
+			$http_get = function ($http_url) use (&$status,$dest,$path) {
+				$client = netHttp::initClient($http_url,$path);
+				if ($client !== false) {
+					$client->setTimeout(4);
+					$client->setUserAgent($_SERVER['HTTP_USER_AGENT']);
+					$client->useGzip(false);
+					$client->setPersistReferers(false);
+					$client->setOutput($dest);
+					$client->get($path);
+					$status = (int) $client->getStatus();
+				}
+				return $client;
+			};
+
+			$client = $http_get($url);
+			if ($status >= 400) {
+				// If original URL uses HTTPS, try with HTTP
+				$url_parts = parse_url($client->getRequestURL());
+				if (isset($url_parts['scheme']) && $url_parts['scheme'] == 'https') {
+					// Replace https by http in url
+					$url = preg_replace('/^https(?=:\/\/)/i','http',$url);
+					$client = $http_get($url);
+				}
+			}
+			if ($status != 200) {
 				@unlink($dest);
 				throw new Exception();
Index: inc/dbschema/upgrade.php
===================================================================
--- inc/dbschema/upgrade.php	(revision 3314)
+++ inc/dbschema/upgrade.php	(revision 3326)
@@ -540,5 +540,5 @@
 		}
 
-		if (version_compare($version,'2.10','<='))
+		if (version_compare($version,'2.10','<'))
 		{
 			@unlink(DC_ROOT.'/'.'admin/js/jsUpload/vendor/jquery.ui.widget.js');
@@ -590,4 +590,17 @@
 		}
 
+		if (version_compare($version,'2.11','<'))
+		{
+			// Remove the CSP report file from it's old place
+			@unlink(DC_ROOT.'/admin/csp_report.txt');
+
+			# Some new settings should be initialized, prepare db queries
+			$strReq = 'INSERT INTO '.$core->prefix.'setting'.
+					' (setting_id,setting_ns,setting_value,setting_type,setting_label)'.
+					' VALUES(\'%s\',\'system\',\'%s\',\'%s\',\'%s\')';
+			$core->con->execute(
+				sprintf($strReq,'csp_admin_report_only',false,'boolean','CSP Report only violations (admin)'));
+		}
+
 		$core->setVersion('core',DC_VERSION);
 		$core->blogDefaults();
Index: inc/prepend.php
===================================================================
--- inc/prepend.php	(revision 3316)
+++ inc/prepend.php	(revision 3347)
@@ -142,5 +142,5 @@
 # Constants
 define('DC_ROOT',path::real(dirname(__FILE__).'/..'));
-define('DC_VERSION','2.10.2');
+define('DC_VERSION','2.11-dev');
 define('DC_DIGESTS',dirname(__FILE__).'/digests');
 define('DC_L10N_ROOT',dirname(__FILE__).'/../locales');
Index: plugins/antispam/_admin.php
===================================================================
--- plugins/antispam/_admin.php	(revision 2849)
+++ plugins/antispam/_admin.php	(revision 3333)
@@ -91,5 +91,5 @@
 		$ttl = $settings->antispam->antispam_moderation_ttl;
 		echo
-		'<div class="fieldset"><h4>Antispam</h4>'.
+		'<div class="fieldset"><h4 id="antispam_params">Antispam</h4>'.
 		'<p><label for="antispam_moderation_ttl" class="classic">'.__('Delete junk comments older than').' '.
 		form::field('antispam_moderation_ttl', 3, 3, $ttl).
Index: plugins/antispam/_define.php
===================================================================
--- plugins/antispam/_define.php	(revision 2566)
+++ plugins/antispam/_define.php	(revision 3333)
@@ -19,5 +19,9 @@
 	array(
 		'permissions' =>	'usage,contentadmin',
-		'priority' =>		10
+		'priority' =>		10,
+		'settings'	=>		array(
+								'self' => '',
+								'blog' => '#params.antispam_params'
+							)
 	)
 );
Index: plugins/blowupConfig/index.php
===================================================================
--- plugins/blowupConfig/index.php	(revision 2849)
+++ plugins/blowupConfig/index.php	(revision 3340)
@@ -318,5 +318,5 @@
 	'<h5 class="pretty-title">'.__('Top image').'</h5>'.
 	'<p class="field"><label for="top_image">'.__('Top image').'</label> '.
-	form::combo('top_image',$top_images,($blowup_user['top_image'] ? $blowup_user['top_image'] : 'default')).'</p>'.
+	form::combo('top_image',$top_images,($blowup_user['top_image'] ?: 'default')).'</p>'.
 	'<p>'.__('Choose "Custom..." to upload your own image.').'</p>'.
 
Index: plugins/breadcrumb/_admin.php
===================================================================
--- plugins/breadcrumb/_admin.php	(revision 3009)
+++ plugins/breadcrumb/_admin.php	(revision 3333)
@@ -25,5 +25,5 @@
 		$settings->addNameSpace('breadcrumb');
 		echo
-		'<div class="fieldset"><h4>'.__('Breadcrumb').'</h4>'.
+		'<div class="fieldset"><h4 id="breadcrumb_params">'.__('Breadcrumb').'</h4>'.
 		'<p><label class="classic">'.
 		form::checkbox('breadcrumb_enabled','1',$settings->breadcrumb->breadcrumb_enabled).
